searchData={"items":[{"type":"module","title":"nm","doc":"`nm` is tool to help handling deeply nested structure.\nIt works by unnesting your data into a ets table, allowing you to handle transformations in a simple\nand easy way.\nOnce you finished manipulating your data in the way you want, it allows you to nest the data back\nwith all the applied changes.\nIt provides simple operations to get, update and delete values in a meaninful way.\n\nTo keep it as simple as possible, initially we're considering only maps and simple lists as\nnesteable structures.\nWhen unnesting, everytime `nm` finds a nesteable structure, it gonna replace it by `t:nm_ref/0`\nand also unnest it recursevely.\nSo for exemple a list of maps like `[#{}, #{}]`, would be unnested to\n`[{'$nm_ref', Id1}, {'$nm_ref', Id2}]`.\nThis can help handling deeply nested structures because when transforming some data referencing\nit by it's `t:nested_id/0`, you don't need to update all the parent structures for this change\nto take efffect.\nAfter all transformations you can nest the structure again and use it externaly to your system.\n\nKeep in mind that proplists and tuples won't be unnested, so if `nm` finds a tuple while unnesting\nit gonna consider it a literal value for a thing.\nFor exemlo, now let's think of a list with a map and a tuple `[#{}, {1, 2 , 3}]`, after unnesting it\nyou gonna have `[{'$nm_ref', Id}, {1, 2, 3}]`.","ref":"nm.html"},{"type":"function","title":"nm.delete/2","doc":"Removes the node identified by the id.\nAlso remove the reference to the node in the parent and all the subtrees of children of the node.","ref":"nm.html#delete/2"},{"type":"function","title":"nm.fast_delete/2","doc":"","ref":"nm.html#fast_delete/2"},{"type":"function","title":"nm.fast_update/3","doc":"Update a node without removing children nodes or unnesting all it's values.\nUseful when you want to do simple updates that doesn't change relation with children nodes.\nFor example, adding a new field to a map that is a literal or changing the order of a list.","ref":"nm.html#fast_update/3"},{"type":"function","title":"nm.get_node/2","doc":"Returns a node of the table.\nThe node contains the actual value and metadata as the current node id and the parent node id.","ref":"nm.html#get_node/2"},{"type":"function","title":"nm.get_value/2","doc":"Get the actual value of the node.","ref":"nm.html#get_value/2"},{"type":"function","title":"nm.nest/1","doc":"It nests the entire table back into a nested structure.\nRe-nesting the table won't remove anything from the table.","ref":"nm.html#nest/1"},{"type":"function","title":"nm.partial_nest/2","doc":"It nests just a subtree of the table, starting from the id provided.\nJust as `nm:nest/1`, re-nesting the information won't remove it from the table.\nThis is useful when you want to modify an entire subtreee of the data.","ref":"nm.html#partial_nest/2"},{"type":"function","title":"nm.unnest/1","doc":"Take a nested data structure and unnest it into a ets table.","ref":"nm.html#unnest/1"},{"type":"function","title":"nm.update/3","doc":"Update a node of the table with a new value.\nThis operation will discard all children of the node and recursevely unnest all it's values.\nCan be used in conjunction with `nm:partial_nest/2` to change entire subtrees.\nIn case you're changing just literals and not adding or removing a nested data structure,\nyou might want to sue `nm:fast_update/3`.","ref":"nm.html#update/3"},{"type":"type","title":"nm.nested_id/0","doc":"Identifiers for nested structure.\n`root` is the begining of the nested structure, all other inner structures are binaries.\n`null` is used only as parent for `root`.","ref":"nm.html#t:nested_id/0"},{"type":"type","title":"nm.nested_structure/0","doc":"A nested structure of `maps` and `lists`.","ref":"nm.html#t:nested_structure/0"},{"type":"type","title":"nm.nested_table/0","doc":"An ETS table configured as `set` and `protected` with the unnested structure.","ref":"nm.html#t:nested_table/0"},{"type":"type","title":"nm.nm_node/0","doc":"A map with the value of an `t:unnested_structure/0` and it's metadata.\n- `ref`: the `t:nested_id/0` of the structure.\n- `parent`: the `t:nested_id/0` of the parent structure.\n- `value`: the actual `t:unnested_structure/0` value.","ref":"nm.html#t:nm_node/0"},{"type":"type","title":"nm.nm_ref/0","doc":"A tag to reference a value that was unnested","ref":"nm.html#t:nm_ref/0"},{"type":"type","title":"nm.unnested_structure/0","doc":"A unnested strucutre, any value that was another nested_structure is replaced by `t:nm_ref/0`.","ref":"nm.html#t:unnested_structure/0"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}